weipa::RipleyNodes Class Reference

Stores and manipulates ripley mesh nodes. More...

`#include <RipleyNodes.h>`

Inheritance diagram for weipa::RipleyNodes:

## Public Member Functions

| RipleyNodes (const std::string &meshName)
| Constructor with mesh name. More...
| RipleyNodes (RipleyNodes_ptr fullNodes, IntVec &requiredNodes, const std::string &meshName)
| RipleyNodes (const RipleyNodes &m)
| Copy constructor. More...
virtual | ~RipleyNodes ()
| Virtual destructor. More...
bool | initFromRipley (const ripley::RipleyDomain *ripleyDomain)
| Initialises with ripley domain. More...
bool | writeToSilo (DBfile *dbfile)
| Writes node data to a Silo file. More...
virtual void | writeCoordinatesVTK (std::ostream &os, int ownIndex)
| Writes coordinates to a stream in VTK text format. More...
void | setSiloPath (const std::string &path)
| Sets the silo path to be used when saving. More...
const IntVec & | getVarDataByName (const std::string &name) const
| Returns an array of nodal data by the given name. More...
virtual StringVec | getVarNames () const
| Returns a vector with the mesh variable names. More...
virtual std::string | getName () const
| Returns the name of this node mesh. More...
std::string | getFullSiloName () const
| Returns full Silo mesh name, e.g. "/block0000/Nodes". More...
virtual const IntVec & | getNodeIDs () const
| Returns the node ID array. More...
virtual const IntVec & | getNodeDistribution () const
| Returns the node distribution array. More...
virtual const IntVec & | getGlobalNodeIndices () const
| Returns the global node index array. More...
virtual const CoordArray & | getCoords () const
| Returns the coordinates of the mesh nodes. More...
virtual int | getNumDims () const
| Returns the dimensionality of this mesh (2 or 3). More...
virtual int | getNumNodes () const
| Returns the number of mesh nodes. More...
virtual int | getGlobalNumNodes () const
| Returns the total number of mesh nodes for a distributed mesh. More...

## Protected Attributes

CoordArray | coords
int | numDims
| x, y[, z] coordinates of nodes More...
int | numNodes
| dimensionality (2 or 3) More...
int | globalNumNodes
| number of nodes More...
IntVec | nodeID
| global number of nodes More...
IntVec | nodeTag
| node IDs More...
IntVec | nodeDist
| node tags More...
std::string | name
| node distribution More...
std::string | siloPath
| the name of this node mesh More...

## Additional Inherited Members

Protected Member Functions inherited from weipa::NodeData
virtual | ~NodeData ()
| Virtual destructor. More...

## Detailed Description

Stores and manipulates ripley mesh nodes.

This class provides functionality to manipulate the nodes of a ripley domain. It is able to load node data from dump files or retrieve it from a RipleyDomain instance.

## Constructor & Destructor Documentation

## RipleyNodes() [1/3]

weipa::RipleyNodes::RipleyNodes | ( | const std::string & | meshName | ) |

Constructor with mesh name.

## RipleyNodes() [2/3]

weipa::RipleyNodes::RipleyNodes | ( | RipleyNodes_ptr | fullNodes,
|  | IntVec & | requiredNodes,
|  | const std::string & | meshName
| ) |  |

References coords, globalNumNodes, nodeDist, nodeID, nodeTag, numDims, and numNodes.

## RipleyNodes() [3/3]

weipa::RipleyNodes::RipleyNodes | ( | const RipleyNodes & | m | ) |

Copy constructor.

References coords, paso::util::copy(), globalNumNodes, name, nodeDist, nodeID, nodeTag, numDims, and numNodes.

## ~RipleyNodes()

weipa::RipleyNodes::~RipleyNodes | ( |  | ) |

virtual

Virtual destructor.

References coords.

## Member Function Documentation

## getCoords()

virtual const CoordArray& weipa::RipleyNodes::getCoords | ( |  | ) | const

inline virtual

Returns the coordinates of the mesh nodes.

Implements weipa::NodeData.

## getFullSiloName()

std::string weipa::RipleyNodes::getFullSiloName | ( |  | ) | const

inline virtual

Returns full Silo mesh name, e.g. "/block0000/Nodes".

Implements weipa::NodeData.

Referenced by writeToSilo().

## getGlobalNodeIndices()

virtual const IntVec& weipa::RipleyNodes::getGlobalNodeIndices | ( |  | ) | const

inline virtual

Returns the global node index array.

Implements weipa::NodeData.

## getGlobalNumNodes()

virtual int weipa::RipleyNodes::getGlobalNumNodes | ( |  | ) | const

inline virtual

Returns the total number of mesh nodes for a distributed mesh.

Implements weipa::NodeData.

## getName()

virtual std::string weipa::RipleyNodes::getName | ( |  | ) | const

inline virtual

Returns the name of this node mesh.

Implements weipa::NodeData.

## getNodeDistribution()

virtual const IntVec& weipa::RipleyNodes::getNodeDistribution | ( |  | ) | const

inline virtual

Returns the node distribution array.

Implements weipa::NodeData.

## getNodeIDs()

virtual const IntVec& weipa::RipleyNodes::getNodeIDs | ( |  | ) | const

inline virtual

Returns the node ID array.

Implements weipa::NodeData.

## getNumDims()

virtual int weipa::RipleyNodes::getNumDims | ( |  | ) | const

inline virtual

Returns the dimensionality of this mesh (2 or 3).

Implements weipa::NodeData.

## getNumNodes()

virtual int weipa::RipleyNodes::getNumNodes | ( |  | ) | const

inline virtual

Returns the number of mesh nodes.

Implements weipa::NodeData.

## getVarDataByName()

const IntVec & weipa::RipleyNodes::getVarDataByName | ( | const std::string & | name | ) | const

Returns an array of nodal data by the given name.

The name must be one of the names returned by getVarNames().

References nodeID, and nodeTag.

## getVarNames()

StringVec weipa::RipleyNodes::getVarNames | ( |  | ) | const

virtual

Returns a vector with the mesh variable names.

Implements weipa::NodeData.

## initFromRipley()

bool weipa::RipleyNodes::initFromRipley | ( | const ripley::RipleyDomain * | ripleyDomain | ) |

Initialises with ripley domain.

References ripley::RipleyDomain::borrowSampleReferenceIDs(), coords, ripley::RipleyDomain::getDataShape(), ripley::RipleyDomain::getDim(), ripley::RipleyDomain::getLocalCoordinate(), ripley::RipleyDomain::getNodeDistribution(), ripley::RipleyDomain::getNumDataPointsGlobal(), ripley::RipleyDomain::getNumNodesPerDim(), globalNumNodes, nodeDist, nodeID, ripley::Nodes, nodeTag, numDims, and numNodes.

## setSiloPath()

void weipa::RipleyNodes::setSiloPath | ( | const std::string & | path | ) |

inline

Sets the silo path to be used when saving.

## writeCoordinatesVTK()

void weipa::RipleyNodes::writeCoordinatesVTK | ( | std::ostream & | os,
|  | int | ownIndex
| ) |  |

virtual

Writes coordinates to a stream in VTK text format.

Implements weipa::NodeData.

References coords, nodeDist, nodeID, numDims, and numNodes.

## writeToSilo()

bool weipa::RipleyNodes::writeToSilo | ( | DBfile * | dbfile | ) |

Writes node data to a Silo file.

References getFullSiloName(), nodeID, nodeTag, numNodes, and siloPath.

## Member Data Documentation

## coords

CoordArray weipa::RipleyNodes::coords

protected

Referenced by initFromRipley(), RipleyNodes(), writeCoordinatesVTK(), and ~RipleyNodes().

## globalNumNodes

int weipa::RipleyNodes::globalNumNodes

protected

number of nodes

Referenced by initFromRipley(), and RipleyNodes().

## name

std::string weipa::RipleyNodes::name

protected

node distribution

Referenced by RipleyNodes().

## nodeDist

IntVec weipa::RipleyNodes::nodeDist

protected

node tags

Referenced by initFromRipley(), RipleyNodes(), and writeCoordinatesVTK().

## nodeID

IntVec weipa::RipleyNodes::nodeID

protected

global number of nodes

Referenced by getVarDataByName(), initFromRipley(), RipleyNodes(), writeCoordinatesVTK(), and writeToSilo().

## nodeTag

IntVec weipa::RipleyNodes::nodeTag

protected

node IDs

Referenced by getVarDataByName(), initFromRipley(), RipleyNodes(), and writeToSilo().

## numDims

int weipa::RipleyNodes::numDims

protected

x, y[, z] coordinates of nodes

Referenced by initFromRipley(), RipleyNodes(), and writeCoordinatesVTK().

## numNodes

int weipa::RipleyNodes::numNodes

protected

dimensionality (2 or 3)

Referenced by initFromRipley(), RipleyNodes(), writeCoordinatesVTK(), and writeToSilo().

## siloPath

std::string weipa::RipleyNodes::siloPath

protected

the name of this node mesh

Referenced by writeToSilo().

The documentation for this class was generated from the following files:

- RipleyNodes.h
- RipleyNodes.cpp